using System;
using System.Web.UI.WebControls;

using System.Data;
using System.Data.SqlClient;
using System.Configuration;
using System.Collections.Generic;

public partial class CS : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!this.IsPostBack)
        {
            this.BindGrid();
        }
    }

    private void BindGrid()
    {
        string constr = ConfigurationManager.ConnectionStrings["constr"].ConnectionString;
        using (SqlConnection con = new SqlConnection(constr))
        {
            string query = "SELECT CustomerID, City, Country, PostalCode FROM Customers";
            using (SqlDataAdapter sda = new SqlDataAdapter(query, con))
            {
                using (DataTable dt = new DataTable())
                {
                    sda.Fill(dt);
                    gvCustomers.DataSource = dt;
                    gvCustomers.DataBind();
                }
            }
        }
    }

    protected void OnPaging(object sender, GridViewPageEventArgs e)
    {
        this.GetCheckedCheckBoxes();
        gvCustomers.PageIndex = e.NewPageIndex;
        this.BindGrid();
        this.SetCheckedCheckBoxes();
    }       

    private void GetCheckedCheckBoxes()
    {
        int checkBoxIndex;
        List<int> checkBoxArray = this.CheckBoxArray;

        //Loop through the GridView rows.
        int i = 0; 
        foreach (GridViewRow row in gvCustomers.Rows)
        {           
            if (row.RowType == DataControlRowType.DataRow)
            {
                //Reference the CheckBox and calculate its Index.
                CheckBox chk = (CheckBox)row.FindControl("CheckBox1");
                checkBoxIndex = gvCustomers.PageSize * gvCustomers.PageIndex + (i + 1);
                if (chk.Checked)
                {
                    //If CheckBox is checked, add it to the ArrayList.
                    if (checkBoxArray.IndexOf(checkBoxIndex) == -1)
                    {
                        checkBoxArray.Add(checkBoxIndex);
                    }
                }
                else
                {
                    //If CheckBox is unchecked, remove it from the ArrayList.
                    if (checkBoxArray.IndexOf(checkBoxIndex) != -1)
                    {
                        checkBoxArray.Remove(checkBoxIndex);
                    }
                }
            }
            i++;
        }
        this.CheckBoxArray = checkBoxArray;
    }

    private List<int> CheckBoxArray
    {
        get
        {
            if (ViewState["CheckBoxArray"] != null)
            {
                return (List<int>)ViewState["CheckBoxArray"];
            }
            return new List<int>();
        }
        set
        {
            ViewState["CheckBoxArray"] = value;
        }
    }

    private void SetCheckedCheckBoxes()
    {
        int i = 0;
        bool isAllChecked = true;
        foreach (GridViewRow row in gvCustomers.Rows)
        {
            if (row.RowType == DataControlRowType.DataRow)
            {
                //Check if Index is present in ArrayList.
                int checkBoxIndex = gvCustomers.PageSize * (gvCustomers.PageIndex) + (i + 1);
                if (this.CheckBoxArray.IndexOf(checkBoxIndex) != -1)
                {
                    //If present, check it.
                    CheckBox chk = (CheckBox)row.FindControl("CheckBox1");
                    chk.Checked = true;
                    row.Attributes.Add("class", "selected");
                }
                else
                {
                   isAllChecked = false;
                }
            }
            i++;
        }
        //If present, check it.
        CheckBox chkAll = (CheckBox)gvCustomers.HeaderRow.FindControl("chkAll");
        chkAll.Checked = isAllChecked;
    }
}
