Imports System.Data
Imports System.Data.SqlClient
Imports System.Configuration
Imports System.Collections.Generic

Partial Class VB
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(sender As Object, e As EventArgs) Handles Me.Load
        If Not Me.IsPostBack Then
            Me.BindGrid()
        End If
    End Sub

    Private Sub BindGrid()
        Dim constr As String = ConfigurationManager.ConnectionStrings("constr").ConnectionString
        Using con As SqlConnection = New SqlConnection(constr)
            Dim query As String = "SELECT CustomerID, City, Country, PostalCode FROM Customers"
            Using sda As SqlDataAdapter = New SqlDataAdapter(query, con)
                Using dt As DataTable = New DataTable()
                    sda.Fill(dt)
                    gvCustomers.DataSource = dt
                    gvCustomers.DataBind()
                End Using
            End Using
        End Using
    End Sub

    Protected Sub OnPaging(sender As Object, e As GridViewPageEventArgs)
        Me.GetCheckedCheckBoxes()
        gvCustomers.PageIndex = e.NewPageIndex
        Me.BindGrid()
        Me.SetCheckedCheckBoxes()
    End Sub

    Private Sub GetCheckedCheckBoxes()
        Dim checkBoxIndex As Integer
        Dim checkBoxArray As List(Of Integer) = Me.CheckBoxArray

        'Loop through the GridView rows.
        Dim i As Integer = 0
        For Each row As GridViewRow In gvCustomers.Rows
            If row.RowType = DataControlRowType.DataRow Then
                'Reference the CheckBox and calculate its Index.
                Dim chk As CheckBox = CType(row.FindControl("CheckBox1"), CheckBox)
                checkBoxIndex = gvCustomers.PageSize * gvCustomers.PageIndex + (i + 1)
                If chk.Checked Then
                    'If CheckBox is checked, add it to the ArrayList.
                    If checkBoxArray.IndexOf(checkBoxIndex) = -1 Then
                        checkBoxArray.Add(checkBoxIndex)
                    End If
                Else
                    'If CheckBox is unchecked, remove it from the ArrayList.
                    If checkBoxArray.IndexOf(checkBoxIndex) <> -1 Then
                        checkBoxArray.Remove(checkBoxIndex)
                    End If
                End If
            End If
            i += 1
        Next
        Me.CheckBoxArray = checkBoxArray
    End Sub

    Private Property CheckBoxArray As List(Of Integer)
        Get
            If ViewState("CheckBoxArray") IsNot Nothing Then
                Return CType(ViewState("CheckBoxArray"), List(Of Integer))
            End If
            Return New List(Of Integer)()
        End Get
        Set(value As List(Of Integer))
            ViewState("CheckBoxArray") = value
        End Set
    End Property

    Private Sub SetCheckedCheckBoxes()
        Dim i As Integer = 0
        Dim isAllChecked As Boolean = True
        For Each row As GridViewRow In gvCustomers.Rows
            If row.RowType = DataControlRowType.DataRow Then
                'Check if Index is present in ArrayList.
                Dim checkBoxIndex As Integer = gvCustomers.PageSize * (gvCustomers.PageIndex) + (i + 1)
                If Me.CheckBoxArray.IndexOf(checkBoxIndex) <> -1 Then
                    'If present, check it.
                    Dim chk As CheckBox = CType(row.FindControl("CheckBox1"), CheckBox)
                    chk.Checked = True
                    row.Attributes.Add("class", "selected")
                Else
                    isAllChecked = False
                End If
            End If

            i += 1
        Next
        'If present, check it.
        Dim chkAll As CheckBox = CType(gvCustomers.HeaderRow.FindControl("chkAll"), CheckBox)
        chkAll.Checked = isAllChecked
    End Sub
End Class
